<?php
/*
	fichier "lib.php" contenant l'ensemble des fonctions php
	source : les fonctions de base sont issues de rowiki
	04-06-2004 : roWiki, version 1.05, 
				 Author: Marc Rohlfing <rowiki@rowlff.de>
				 Home/Docs/Licensing: www.rowlff.de/rowiki/
	adaptation : réécriture modulaire des fonctions de base et ajouts divers
	25/12/2005 : adapté et modifié par alain marty (marty.alain.free.fr/) 
	02/03/2006 : traitement plus complet des liens
	25/05/2006 : traitement de l'historique sous forme de fichiers séparés
	28/05/2006 : concentration de toutes les fonctions dans ce fichier "lib.php"
	31/05/2006 : réécriture de la fonction build_html()
	18/06/2006 : mise au point de la fonction historique
*/

// 1) functions wiki base

include "perso.php";	// definition des variables externes globales $WIKI_TITLE, $PIEDPAGE et $GLOBALLOCK

/*
	liens internes :	/\[([0-9a-zA-Z\-_ :\.,\(\)\']+)\]/U
	liens absolus :		#\[(.+)\|([:/0-9a-zA-Z\.\#/~\-_%=\?\&amp;,\+]*)\]#U
	images :			#{([http?://0-9a-zA-Z\.\&amp;\#\:/~\-_%=?]*\.(jpg|gif|png))\|(.+)\|(.+)}#i
*/

function page_format( $pages_dir, &$content )
{
	// 1) traitement des liens vers des pages internes : [aide] -> <a href="index.php?page=aide">aide</a>
	preg_match_all("/\[([0-9a-zA-Z\-_ :\.,\(\)\']+)\]/U", $content, $matches, PREG_PATTERN_ORDER);
	foreach ($matches[1] as $match)		// affichage différencié des pages existantes ou non
		if (file_exists( $pages_dir."/".$match.".txt"))
			$content = str_replace("[$match]", "<a href=\"index.php?page=$match\">$match</a>", $content);
		else
			$content = str_replace("[$match]", "<a class=\"pending\" href=\"index.php?page=$match\">$match</a>", $content);

	// 2) traitement des liens absolus : [pixar|http://www.pixar.com] -> <a href="http://www.pixar.com">pixar</a>
	$content = preg_replace('#\[(.+)\|([:/0-9a-zA-Z\.\#/~\-_%=\?\&amp;,\+]*)\]#U', '<a href="$2">$1</a>', $content);

	// 3) traitement des images : {URL_image|hauteur|infobulle} -> <img src="URL_image" height="hauteur" title="infobulle" />
	$content = preg_replace('#{([http?://0-9a-zA-Z\.\&amp;\#\:/~\-_%=?]*\.(jpg|gif|png))\|(.+)\|(.+)}#i', '<img src="$1" height="$3" title="$4" />', $content);
}

function microtime_float()
{
  list($usec, $sec) = explode(" ", microtime());
  return ((float)$usec + (float)$sec);
}
/*
	au départ le wiki est deverrouillé
	sous réserve de connaître le couple (login:mot de passe)
	on peut le verrouiller globalement
	on peut rendre toujours éditable une page avec %ouvert%
	on peut inverser le verrouillage d'une page avec %invert%
	le controle du verrouillage global ou partiel du wiki
	peut donc être réalisé depuis le navigateur
*/
function is_editable( $nom_fichier )
{	global $GLOBALLOCK;	// définie dans le fichier "perso.php"
	$ouvert = "%ouvert%";
	$invert = "%invert%";
	$file = @fopen($nom_fichier, "r");
	$cont = @fread($file, 255);				// lit les 255 premiers caractères
	@fclose($file);
	if (!$GLOBALLOCK)						// deverrouillage global
	{	if (!eregi($invert, $cont ))		// page sans marquage invert
			return true;					// éditable
		else								// page marquée invert
			return false;					// verrouillée
	}
	else									// verrouillage global
	{	if (eregi($ouvert, $cont ))			// page marquée ouvert
			return true;					// toujours éditable
		else								
		{	if (!eregi($invert, $cont ))	// page non marquée invert
				return false;				// verrouillée
			else							// page marquée invert
				return true;				// éditable
		}
	}
}

function read_template( $filename )
{	if (! $file = @fopen($filename, "r"))
		die($filename." is missing!");
	$temp = fread($file, filesize($filename));
	fclose($file);
	return $temp;
}

function read_content_time( $pages_dir, $pages_title, $time_format, $new_page, &$act, &$content, &$time )
{	if (($file = @fopen($pages_dir . $pages_title . ".txt", "r")) || $act <> "") 
	{	$time = strftime($time_format, @filemtime($pages_dir . $pages_title . ".txt"));
		$content = "\n" . @fread($file, @filesize($pages_dir . $pages_title . ".txt")) . "\n";
		@fclose($file);
		$content = preg_replace("/\\$/Umsi", "&#036;", $content);
		$content = preg_replace("/\\\/Umsi", "&#092;", $content);
	}
	else 
	{	$act = "edit";
		$time = $new_page;
	}
}

function search( $pages_dir, &$content, &$time, $qqq )
{	$dir = opendir(getcwd() . "/" . $pages_dir);
	$content .="<p>";
	while ($file = readdir($dir)) 
	{	if (preg_match("/.txt/", $file)) 
		{	$handle = fopen($pages_dir . $file, "r");
			$temp = fread($handle, filesize($pages_dir . $file));
			fclose($handle);
			if (preg_match("/$qqq/i", $temp) || preg_match("/$qqq/i", $pages_dir."/".$file)) 
			{	$file = substr($file, 0, strlen($file) - 4);
				$content .= "<a href=\"index.php?page=$file\">$file</a><br />";
			}
		}
	}
	$content .="</p>";
	$time = "-";
}

function recent( $pages_dir, $time_format,  &$content, &$time )
{	$dir = opendir(getcwd() . "/".$pages_dir);
	 while ($file = readdir($dir))
		if (preg_match("/.txt/", $file))
			$filetime[$file] = filemtime($pages_dir . $file);
	arsort($filetime);
	$content .= "<h4>Les 20 derni&egrave;res pages modifi&eacute;es :</h4>";
	$content .= "<table border='1' cellspacing='0' cellpadding='2' bgcolor='white'>";
	$filetime = array_slice($filetime, 0, 20);
	foreach ($filetime as $filename => $timestamp) 
	{	$filename = substr($filename, 0, strlen($filename) - 4);
		$content .= "<tr><td><a href=\"index.php?page=$filename\">$filename</a></td><td>" 
				 . strftime($time_format, $timestamp) 
				 . "</td><td><a href='histoire.php?historique=".$filename."'>historique</a></td></tr>";
	}
	$content .= "</table>";
	$time = "-";
}

function get_content( $page_title, $done_button, $default_content, $annuler, &$content )
{	if ($content == '')
		$content = $default_content;
	$content = 	"<form method=\"post\" action=\"index.php\">".
        		"<textarea name=\"content\" cols=\"90\" rows=\"25\" class=\"widgEditor nothing\">".$content."</textarea>".
        		"<input type=\"hidden\" name=\"page\" value=\"".$page_title."\" /><br />".
        		"<span class=\"annuler\"><a href=\"javascript:history.back()\">".$annuler."</a></span>".
        		"<input type=\"submit\" value=\"".$done_button."\" accesskey=\"s\" /></form>";
}

function write_changes( $pages_dir, $backup_dir, $time_format )
{	if (!$file = @fopen($pages_dir . stripslashes($_POST["page"]) . ".txt", "w"))
		die("Could not write page!");
	if (get_magic_quotes_gpc())
		fputs($file, trim(stripslashes($_POST["content"])));
	else
		fputs($file, trim($_POST["content"]));	    
	fclose($file);        
	if ($backup_dir <> '') 
	{	$complete_dir_s = $backup_dir . $_POST["page"] . "/";
		if (! $dir = @opendir($complete_dir_s))
			mkdir($complete_dir_s);
		if (! $file = @fopen($complete_dir_s . date("Ymd-His", mktime(date("H"))) . ".bak", "a"))
			die("Could not write backup of page!");
		 fputs($file, date("Y/m/d H:i:s", mktime(date("H"))) . " / " . " (" . $_SERVER['REMOTE_ADDR'] . ") "
		 		. "\n-----------------------------------------------------------------------------\n");
		if (get_magic_quotes_gpc())
			 fputs($file, trim(stripslashes($_POST["content"])));
		else
			 fputs($file, trim($_POST["content"]) . "\n\n");            
		 fclose($file);
	}
	header("location: index.php?page=" . urlencode(stripslashes($_POST[page])));
}

function get_title( $page, $action, $query, $search_results, $recent_changes, $start_page )
{	if (!$page_title = stripslashes($page)) 
	{	if ($action == "search")
			$page_title = $search_results." \"".$query."\"";
		elseif ($action == "recent")
			$page_title = $recent_changes;
		else
			$page_title = $start_page;
	}
	if (preg_match("/\//", $page_title))	// Catch malicious paths
			$page_title = $start_page;	
	return $page_title;
}

function search_form( $query, $search_button )
{	$form = "<form method='get' action='index.php'>".
			"<input type='hidden' name='action' value='search' />".
			"<input type='text' name='query' value='". $query ."' />".
			"<input type='submit' value='".$search_button."' /></form>";
	return $form;
}

function build_html()
{	//	constantes :
	global $WIKI_TITLE, $PIEDPAGE;	// définies dans le fichier perso.php
	$START_PAGE			=	"accueil";
	$HOME_BUTTON		=	"accueil";
	$HELP_BUTTON		=	"aide";
	$EDIT_BUTTON		=	"&eacute;diter ...";
	$DEFAULT_CONTENT	=	"page vide ...";
	$ANNULER			=	"annuler l'&eacute;dition";
	$DONE_BUTTON		=	"valider l'&eacute;dition";
	$PROTECTED_BUTTON 	=	"page verrouill&eacute;e";
	$SEARCH_BUTTON		=	"rechercher";
	$SEARCH_RESULTS		=	"r&eacute;sultats ";
	$NEW_PAGE			=	"nouvelle page";
	$RECENT_CHANGES		=	"r&eacute;centes";
	$LAST_CHANGE		=	"modifi&eacute; le :";
	$TIME_FORMAT		=	"%d/%m/%y %R";
	$PAGES_DIR			= 	"pages/";
	$BACKUP_DIR			=	"history/";
	$PAGE_PRECEDENTE	=	"pr&eacute;c&eacute;dente";
	$DUREE				=	"dur&eacute;e";

//	phase calcul des variables
	$t0 = microtime_float();
	$action		= '';
	$content	= '';
	$time		= '';
	// $action
	$action = (!isset( $_GET["action"])) ? "" : $_GET["action"];
	$page = (!isset( $_GET["page"])) ? "" : $_GET["page"];
	$query = (!isset( $_GET["query"])) ? "" : $_GET["query"];
	$query = ereg_replace("[^[:space:]a-zA-Z0-9_éèçàù.-]", "", $query);	// tout sauf nasty things ; traitement partiel des accents ...		
	$page_title = get_title( $page, $action, $query, $SEARCH_RESULTS, $RECENT_CHANGES, $START_PAGE );
	$search = search_form( $query, $SEARCH_BUTTON );	
	if ($_SERVER["REQUEST_METHOD"] == "POST") 
		write_changes( $PAGES_DIR, $BACKUP_DIR, $TIME_FORMAT );	
	read_content_time( $PAGES_DIR, $page_title, $TIME_FORMAT, $NEW_PAGE, $action, $content, $time );
	if ($action == "edit")
		get_content( $page_title, $DONE_BUTTON, $DEFAULT_CONTENT, $ANNULER, $content );	
	if ($action == "search")
		search( $PAGES_DIR, $content, $time, $query );
	elseif ($action == "recent") 
		recent( $PAGES_DIR, $TIME_FORMAT, $content, $time );
	elseif ($action <> "edit")
		page_format( $PAGES_DIR, $content );

//	phase remplacements :
	$html = read_template("template.html");
	if ($page_title == $START_PAGE && $action <> "search")
		$html = preg_replace('/{HOME}/', $HOME_BUTTON, $html);
	else
		$html = preg_replace('/{HOME}/', "<a href=\"index.php\">".$HOME_BUTTON."</a>", $html);	
	if ($page_title == $HELP_BUTTON)
		$html = preg_replace('/{HELP}/', $HELP_BUTTON, $html);    
	else
		$html = preg_replace('/{HELP}/', "<a href=\"index.php?page=".$HELP_BUTTON."\">".$HELP_BUTTON."</a>", $html);		
/*
	if ($action == "recent")
	{	$html = preg_replace('/{RECENT_CHANGES}/', '', $html);
		$html = preg_replace('/{TIME}/','', $html);
	}
	else
	{	$html = preg_replace('/{RECENT_CHANGES}/', "<a href=\"index.php?action=recent\">".$RECENT_CHANGES."</a>", $html);	
		$html = preg_replace('/{TIME}/', $time, $html);
	}
*/

	if ($action == "recent")
		$html = preg_replace('/{TIME}/','', $html);
	else
		$html = preg_replace('/{TIME}/', $time, $html);

	if ($action == "edit" || $action <> "")
		$html = preg_replace('/{EDIT}/', $EDIT_BUTTON, $html);
	elseif (is_editable( $PAGES_DIR . $page_title . ".txt" ))
		 $html = preg_replace('/{EDIT}/', "<a href=\"index.php?page=".$page_title."&action=edit\">".$EDIT_BUTTON."</a>", $html);
	else
		$html = preg_replace('/{EDIT}/', $PROTECTED_BUTTON, $html);	
	$html = preg_replace('/{WIKI_TITLE}/', $WIKI_TITLE, $html);
	$html = preg_replace('/{PAGE_TITLE}/', $page_title, $html);
	$html = preg_replace("/{NAV}/", "<a href='javascript:history.back();'>".$PAGE_PRECEDENTE."</a>", $html);
	$html = preg_replace('/{LAST_CHANGE}/', $LAST_CHANGE, $html);
	$html = preg_replace('/{INFOS}/',"||| votre IP : " . $_SERVER['REMOTE_ADDR']. " ||| date : " . date("j\/m\/y\|H\:i") . " ||| cpu ". (round((microtime_float()-$t0)*1000)) . " ms", $html);
	if ($page==aide)
		$html = preg_replace('/{SEARCH}/', $search, $html);
	else
		$html = preg_replace('/{SEARCH}/', '', $html);
	$html = preg_replace('/{PIEDPAGE}/', $PIEDPAGE  , $html);
	$html = preg_replace("/{CONTENT}/", $content, $html);

	return $html;
}

//	2) fonctions historique

function afficher_formulaire_historique()
{	$chaine = '<form name="filtre" method="post" action="">';
	$chaine .= '<input type="hidden" name="phase" value="traitement">';
	$chaine .= 'Nom&nbsp;de&nbsp;la&nbsp;page&nbsp;: ';
	$chaine .= '<input type="text" name="nom_page" size="20" maxlength="20">';
	$chaine .= '<input type="submit" value="Ouvrir">';
	$chaine .= '<input type="button" value="Annuler" onclick="location.href=\'index.php?page=aide\'">';
	$chaine .= '</form>';
	return $chaine;	
}


function afficher_page_historique( $nom_page )
{	if( isset($_POST['nom_page'] ) )
		$nom_page = $_POST['nom_page'];
	$chaine = '';
	$nom_fichier = getcwd() . "/history/".$nom_page.".bak";	
	$repertoire = getcwd() . "/history/" . $nom_page;
	if ( is_dir($repertoire)  && $dir = opendir($repertoire) )
	{	$chaine .= '<h4>page '.$nom_page.'</h4>';
		$chaine .= '<form>';
		$chaine .= '<br><input type="button" value="Retour" onclick="location.href=\'index.php?action=recent\'">';
		$chaine .= '</form>';
		$chaine .= '<p>Liste des 20 dernières sauvegardes de la page en ordre antichronologique.';
		$chaine .= '<br>Chaque lien donne accès au texte brut de la sauvegarde datée '; 
		$chaine .= '(format : annnée.mois.jour-heure.minute.seconde) qui pourra être copié/collé dans l\'éditeur de page. ';
		$chaine .= '<br>En fonction des réglages du navigateur, ce texte apparaît dans une page du navigateur ';
		$chaine .= 'ou est téléchargé en local pour être ouvert par un éditeur de texte approprié. ';
		$chaine .= '<br>Le texte peut ne pas s\'afficher correctement, ce qui est sans importance pour le résultat final ; dans ce cas ';
		$chaine .= 'il est quand même préférable de forcer l\'encodage UTF-8 dans le menu du navigateur ou de l\'éditeur de texte.</p>';
		$i = 0;
/*
		while ($file = readdir($dir))
			if (preg_match("/.bak/", $file))
			{	$myfile = "history/" . $nom_page . "/" . $file;
				$lien_fichier = '<a href="' . $myfile . '">' . $file . '</a>';
				$poids_fichier = ' [ ' . @filesize($myfile) . ' caractères ]';
				$tableau[$i] = array( $lien_fichier, $poids_fichier );
				$i++;			
			}
		closedir($dir);
		rsort($tableau);
		$chaine .= 'nombre de sauvegardes : ' . count($tableau) . '.<br>';
		for( $i=count($tableau)-1; $i>=0; $i--)
			$chaine .= $tableau[$i][0] . $tableau[$i][1] . '[ ' . $i . ' ]<br>';	
*/
        while ($file = readdir($dir))
            if (preg_match("/.bak/", $file))
            {	$myfile = "history/" . $nom_page . "/" . $file;		// history/acm2/20060618-161459.bak 
				$filetime[$file] = filemtime($myfile);				// 
            }
        closedir($dir);
        arsort($filetime);
        $filetime = array_slice($filetime, 0, 20);
        $N = count($filetime);
		$chaine .= '<p>Nombre de sauvegardes : ' . $N . '.</p><hr />';
        $i=0;
        foreach ($filetime as $filename => $timestamp) 
        {	$filename_short = substr($filename, 0, strlen($filename) - 4);
        //    $chaine .= "<a href=\"history/" .$nom_page . "/" . $filename . "\">" . $filename_short . "</a> (" . strftime("%Y/%m/%d %R", $timestamp) . ")<br />";
            $chaine .= "<a href=\"history/" .$nom_page . "/" . $filename . "\">" . $filename_short . "</a> [" . ($N-$i) . "]<br />";
            $i++;
        }
	}
	elseif ( file_exists($nom_fichier) && $fichier = @fopen($nom_fichier, "r") )
	{	$contenu = @fread($fichier, @filesize($nom_fichier));		
		@fclose($fichier);
		$poids_fichier = @filesize($nom_fichier)/1024;
		$chaine .= '<h4>page '.$nom_page.'</h4>';
		$chaine .= '<p>Affichage de l\'historique de la page sous forme de liste des sauvegardes successives.</p>';
		$chaine .= '<p>Poids de la page : ' . $poids_fichier . ' ko.</p>';
		$chaine .= '<form>';
		$chaine .= '<textarea name="content" cols="90" rows="25">'.$contenu.'</textarea>';
		$chaine .= '<br><input type="button" value="Retour" onclick="location.href=\'index.php?action=recent\'">';
		$chaine .= '</form>';
	}
	else
	{	$chaine = afficher_formulaire_historique();
	}
	return $chaine;
}

//	3) fonctions téléchargement

function afficher_formulaire_telechargement()
{	$chaine = '';
	$chaine .= '<form enctype="multipart/form-data" action="" method="post">';
	$chaine .= '<input type="hidden" name="phase" value="traitement">';
	$chaine .= '<input name="le_fichier" type="file" size="40" maxlength="102400" />';
	$chaine .= '<input type="submit" value="Télécharger le fichier" />';
	$chaine .= '<p><input type="button" value="Fermer" onclick="location.href=\'../index.php?page=aide\';"></p>';
	$chaine .= '</form>';
	return $chaine;
}
function executer_telechargement()
{	$chemin = "./";
	$nom   	= $_FILES['le_fichier']['name'];
	$type   = $_FILES['le_fichier']['type'];
	$taille	= $_FILES['le_fichier']['size'];
	$temp 	= $_FILES['le_fichier']['tmp_name'];
	$basenom = basename( $nom );
	if ($taille > 100*1024)
		echo "Désolé, la taille du fichier ".$basenom." doit être inférieure à 100 ko !";
	elseif (	$type != "image/jpeg" && 		// *.jpg ou *.jpeg
				$type != "image/gif" && 		// *.gif
				$type != "image/png" && 		// *.png
				$type != "application/pdf" &&	// *.pdf
				$type != "text/html" &&			// *.html ou *.htm
				$type != "text/css" &&			// *.css
				$type != "audio/x-wav" &&		// *.wav
				$type != "video/quicktime"		// *.qt, *.mov
			)
		echo "Le type du fichier ".$basenom." n'est pas dans la suite : [ jp(e)g, gif, png, pdf, htm(l), css, wav, qt, mov] !";
	else
	{	if(!move_uploaded_file($temp, $chemin . $basenom))
			echo "Erreur de transfert dans le dossier de téléchargement !";
		else
		{	//if (!chmod( $nom, 0644 ))	// -rw-r--r-- (644)	non autorisé sur free, mais on a rw------- (600), donc OK
			//	echo "changement de permission inopérant sur le fichier ".$basenom." !";
			//else
				echo "Le fichier ".$basenom." (".$taille." octets, ".$type.") a bien été téléchargé !";
		}
    }
} 

//	4) fonctions verrouillage

function afficher_formulaire_verrouillage()
{	$chaine = '';
	$chaine .= '<form name="filtre" method="post" action="">';
	$chaine .= '<input type="hidden" name="phase" value="traitement">';
	$chaine .= '<table style="width: 200pt;"><tr>';
	$chaine .= '	<td align="right">Login&nbsp;:</td>';
	$chaine .= '	<td><input type="text" name="login" size="20" maxlength="10"></td>';
	$chaine .= '</tr><tr>';
	$chaine .= '	<td align="right">Mot&nbsp;de&nbsp;passe&nbsp;:</td>';
	$chaine .= '	<td><input type="password" name="passe" size="20" maxlength="10">';
	$chaine .= '</tr><tr>';
	$chaine .= '	<td align="right"><input type="button" value="Fermer" onclick="location.href=\'index.php?page=aide\';"></td>';
	$chaine .= '	<td><input type="submit" value="Verrouiller/Deverrouiller"></td>';
	$chaine .= '</tr></table></form>';
	return $chaine;	
}

function executer_verrouillage()
{	include( "perso.php" );
	$fichier = fopen("perso.php", "r") or die($php_errormsg);	
	$contenu = fread($fichier, filesize("perso.php"));		
	fclose($fichier);
	$chaine = '<h6> ';
	if ( ($_POST['login'] == $LOGIN) && ($_POST['passe'] == $PASSE) )
	{	if (!$GLOBALLOCK)
		{	$contenu = preg_replace('/false/', 'true', $contenu);
			$chaine .= 'Le site est verrouillé globalement !';
			$fichier = fopen("perso.php", "w") or die($php_errormsg);
			fwrite( $fichier, $contenu );
			fclose( $fichier ); 
		}
		elseif ($GLOBALLOCK)
		{	$contenu = preg_replace('/true/', 'false', $contenu);
			$chaine .= 'Le site est déverrouillé globalement';
			$fichier = fopen("perso.php", "w") or die($php_errormsg);
			fwrite( $fichier, $contenu );
			fclose( $fichier ); 
		}
		else
			$chaine .= 'La valeur à modifier doit être true ou false !';	
	}
	else
		$chaine .= 'Mauvais login et mot de passe !';
	$chaine .= '</h6>';
	return $chaine;
}

?>